
;; .emacs
 
;;; uncomment this line to disable loading of "default.el" at startup
;; (setq inhibit-default-init t)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;  OS μ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defvar run-unix
  (or (equal system-type 'gnu/linux)
      (equal system-type 'usg-unix-v)))
(defvar run-w32
  (and (null run-unix)
       (or (equal system-type 'windows-nt)
           (equal system-type 'ms-dos))))
(defvar run-emacs20
  (and (equal emacs-major-version 20)
       (null (featurep 'xemacs))))
(defvar run-emacs21
  (and (equal emacs-major-version 21)
       (null (featurep 'xemacs))))
(defvar run-meadow (featurep 'meadow))
(defvar run-meadow1 (and run-meadow run-emacs20))
(defvar run-meadow2 (and run-meadow run-emacs21))
(defvar run-xemacs (featurep 'xemacs))
(defvar run-xemacs-no-mule
  (and run-xemacs (not (featurep 'mule))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; ܸĶ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(cond
 (run-meadow2
  ;; Meadow2 Ѥ ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  (set-language-environment "Japanese")
  (mw32-ime-initialize)
  (setq default-input-method "MW32-IME")
  (set-keyboard-coding-system 'sjis)
  ;; Windows IME  ON/OFF ֤⡼ɥ饤ɽ
  (setq mw32-ime-show-mode-line t) ; ǥեȤ t(ɽ)
  
  ;; ⡼ɥ饤ɽ IME Υ󥸥򥫥ޥ
  ;;  OFF : [--]
  ;;  ON  : []
  (setq-default mw32-ime-mode-line-state-indicator "[--]")
  (setq mw32-ime-mode-line-state-indicator "[--]")
  (setq mw32-ime-mode-line-state-indicator-list
	'("[--]" "[]" "[--]"))
  (add-hook 'mw32-ime-on-hook
	  (function (lambda () (set-cursor-height 2))))
  (add-hook 'mw32-ime-off-hook
	  (function (lambda () (set-cursor-height 4))))
  ;; ޤ ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  (setq test t)
  )
 (run-xemacs
  ;; XEmacs Ѥ ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;; ʸɤܸ EUC ˤޤ
  (cond ((boundp 'MULE)
	 (set-display-coding-system *euc-japan*)
	 (set-default-file-coding-system *euc-japan*))
	(t (set-language-environment "Japanese")
	   (set-terminal-coding-system 'euc-japan-unix) ; emacs -nw ʸʤ
	   (set-buffer-file-coding-system 'euc-japan-unix)
	   (set-keyboard-coding-system 'euc-japan-unix)))
  ;; ޤ ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  (setq test nil)
  )
 )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; font-setting.el
;;
;; 
;;   [Options] -> Set Font/Font SetꤵƤեȤǧǤ
;;   ޤϡShift + å
(cond
 (run-w32
  (let ((define-font
	  (function 
	   (lambda (fn sz)
	     (let (fsn fss)
	       (setq fsn (format "%s %d" fn sz))
	       (setq sz (- sz))
	       (setq fss
		     `((spec
			((:char-spec ascii :height any)
			 strict
			 (w32-logfont ,fn 0 ,sz 400 0 nil nil nil 0 1 3 0))
			((:char-spec ascii :height any :weight bold)
			 strict
			 (w32-logfont ,fn 0 ,sz 700 0 nil nil nil 0 1 3 0)
			 ((spacing . -1)))
			((:char-spec ascii :height any :slant italic)
			 strict
			 (w32-logfont ,fn 0 ,sz 400 0   t nil nil 0 1 3 0))
			((:char-spec ascii :height any :weight bold :slant italic)
			 strict
			 (w32-logfont ,fn 0 ,sz 700 0   t nil nil 0 1 3 0)
			 ((spacing . -1)))
			((:char-spec japanese-jisx0208 :height any)
			 strict
			 (w32-logfont ,fn 0 ,sz 400 0 nil nil nil 128 1 3 0))
			((:char-spec japanese-jisx0208 :height any :weight bold)
			 strict
			 (w32-logfont ,fn 0 ,sz 700 0 nil nil nil 128 1 3 0)
			 ((spacing . -1)))
			((:char-spec japanese-jisx0208 :height any :slant italic)
			 strict
			 (w32-logfont ,fn 0 ,sz 400 0   t nil nil 128 1 3 0))
			((:char-spec japanese-jisx0208 :height any :weight bold :slant italic)
			 strict
			 (w32-logfont ,fn 0 ,sz 700 0   t nil nil 128 1 3 0)
			 ((spacing . -1))))))
	       (if (w32-list-fonts fsn)
		   (w32-change-font fsn fss)
	       (w32-add-font fsn fss))
	       )))
	  ))
    (funcall define-font "MS Gothic" 10)
    (funcall define-font "MS Gothic" 12)
    (funcall define-font "MS Gothic" 14)
    (funcall define-font "MS Gothic" 16)
    (funcall define-font "MS Gothic" 18)
    (funcall define-font "MS Gothic" 20)
    (funcall define-font "MS Gothic" 22)
    (funcall define-font "MS Mincho" 10)
    (funcall define-font "MS Mincho" 12)
    (funcall define-font "MS Mincho" 14)
    (funcall define-font "MS Mincho" 16)
    (funcall define-font "MS Mincho" 18)
    (funcall define-font "MS Mincho" 20)
    (funcall define-font "MS Mincho" 22)
    )
  ;; ǥեȥեȤ
  (add-to-list 'default-frame-alist '(font . "MS Gothic 18"))
  )
 )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Shell - Shell ⡼ɡShell ޥɤ
;;;

(cond
 (run-w32
  ;; ƥĶѿɲ
  ;; C:\cygwin\bin;c:\cygwin\sbin;C:\cygwin\usr\sbin;C:\cygwin\usr\bin;C:\cygwin\usr\local\bin;
  ;;; Cygwin  bash Ȥ
  (setq explicit-shell-file-name "bash.exe") ; ⡼
  (setq shell-file-name "sh.exe")            ; 륳ޥ
  (setq shell-command-switch "-c")
  ;;; argument-editing 
  (require 'mw32script)
  (mw32script-init)
  ;;; coding-system 
  (add-hook 'shell-mode-hook
          (lambda ()
           (set-buffer-process-coding-system 'undecided-dos 'sjis-unix)))
  ;;; ^M Ȥ
  (add-hook 'comint-output-filter-functions 'shell-strip-ctrl-m nil t)
  ;;; shell-modeǤ䴰 (for drive letter)
  (setq shell-file-name-chars "~/A-Za-z0-9_^$!#%&{}@'`.,;()-")
  ;; ˥ۡǥ쥯ȥ꤫
  (cd "~")
 )
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ƥȥ⡼ɤǾ auto-fill
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 (add-hook 'text-mode-hook
           '(lambda () (auto-fill-mode 1)))
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ޤ֤ν
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(setq-default fill-column 80)
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Хååץե¸
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(setq make-backup-files t)
(setq backup-directory-alist
      (cons (cons "\\.*$" (expand-file-name "~/backup"))
            backup-directory-alist))

;; turn on font-lock mode
(global-font-lock-mode t)
 
;; enable visual feedback on selections
;(setq transient-mark-mode t)

;; ֹɽ
(line-number-mode 1)
;; ֹɽ
(column-number-mode 1)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; /ɽ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(cond
 ((>= emacs-major-version 21) ;; Vine2.6  emacs ǤԶȯ
  (setq display-time-24hr-format t)
  (setq display-time-format "%x(%a) %R")
  (setq display-time-day-and-date t)
  (display-time)
  ))

;; emacsΥץ˥󥰲ɽ
(setq inhibit-startup-message t)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; -nw
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; طʿλ hilit19.el ľܻ
;; M-x list-faces-display
;; M-x list-colors-displayǿΰ
;; yellow/red-bold-underline 
;; [reverse-](fgcolor[/bgcolor])[-bold][-italic][-underline] 
;; c-mode  emacs-lisp-mode Ǥ̵
;; setq hilit-mode-enable-list '(not c-mode emacs-lisp-mode))
;;(set-background-color "OldLace")
(cond
 (window-system
  
  (require 'hilit19)                  ;; ͽ˿Ĥ
  (set-background-color "black")
  (set-foreground-color "white")
  )
 (t   (message "running unknown Emacs"))
 )

;; emacs-goodies-el п
(when (locate-library "color-theme")
  (require 'color-theme)
  (color-theme-dark-laptop))

;(hilit-translate
;     comment 'LightBlue
;     include 'Yellow
;     define  'Plum
;     defun   'LightPink
;     decl    'LemonChiffon
;     type    'Goldenrod
;     crossref    'Gold
;     keyword 'GreenYellow
;     label   'OliveDrab2
;     string  'Bisque
;     struct  'LightYellow
;     gnus-group-unsubscribed 'Goldenrod
;     gnus-group-empty    'Plum
;     gnus-group-full         'GreenYellow
;     gnus-group-overflowing  'Yellow
;     summary-seen            'LightBlue
;     summary-killed          'CadetBlue
;     summary-Xed             'OliveDrab2
;     summary-deleted         'Firebrick
;     summary-unread          'Yellow
;     summary-new             'LightBlue
;     summary-current         'default/LightSkyBlue3
;     msg-subject             'LightBlue
;     msg-from                'Bisque
;     msg-header              'Yellow
;     msg-separator           'Black/Tan
;     msg-quote               'LightYellow
;     dired-directory 'Gray80
;     dired-link      'Bisque-underline
;     dired-ignored   'LightBlue
;     dired-deleted   'Gray60
;     dired-marked    'Yellow
;     jargon-entry    'PaleGreen
;     jargon-xref     'LightPink
;     jargon-keyword  'Goldenrod-underline
;     rule            'Bisque-underline)

;; С򱦤˽Ф
(cond (window-system (set-scroll-bar-mode 'right))) 

;; ХåڡإפǤʤХåڡ˳Ƥ
(global-set-key "C-h" 'delete-backward-char) 

;; "." ǡ֡ס"," ǡ֡פ
(setq use-kuten-for-period nil)
(setq use-touten-for-comma nil)

;; nnפǡ֤פ
(setq enable-double-n-syntax t)

;; ޥο
(set-mouse-color "Black") 

;; ο
(set-cursor-color "Black")

;; ɸΥ᥸㡼⡼ɤtext-mode
(setq default-major-mode 'text-mode)

;; ϰϤ򸫤褦ˤƤ
(setq transient-mark-mode t)

;; Kernighan & Ritchie ˤ
(setq c-default-style "k&r")

;; Swap ^H and DEL
(global-set-key [delete] 'delete-char)
(global-set-key [backspace] 'delete-backward-char)
;;(load "term/bobcat")  ; emacs -nw ˤ Backspace ͭˤ

;; BackSpace ָפǥ4塤֤ϥڡŸ
(add-hook 'c-mode-common-hook
     	  '(lambda ()
             (progn
               (c-toggle-hungry-state 1)
               (setq c-basic-offset 4 indent-tabs-mode nil))))

;; .hpp .inc .h  C++ γĥҤȤ
(setq auto-mode-alist
      (append
       '(("\\.hpp$" . c++-mode)
         ("\\.inc$" . c++-mode)
         ("\\.h$"   . c++-mode)
         ) auto-mode-alist))

;; cc-mode
;; TAB ǥǥȤƤ
;; C-j ǲԤƥǥȤƤ
;; M-; ǥȤǤ

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ޥΥۥ륹륹ԡɤĴ
;; (Ϣ³Ʋ󤷤ƤȤȤǤʤᤵˤʤäƤޤ)

(defun scroll-down-with-lines ()
  "" (interactive) (scroll-down 3))
(defun scroll-up-with-lines ()
  "" (interactive) (scroll-up 3))
(global-set-key [wheel-up]
                '(lambda () "" (interactive) (scroll-down 1)))
(global-set-key [wheel-down]
                '(lambda () "" (interactive) (scroll-up 1)))
(global-set-key [double-wheel-up]
                '(lambda () "" (interactive) (scroll-down 1)))
(global-set-key [double-wheel-down]
                '(lambda () "" (interactive) (scroll-up 1)))
(global-set-key [triple-wheel-up]
                '(lambda () "" (interactive) (scroll-down 2)))
(global-set-key [triple-wheel-down]
                '(lambda () "" (interactive) (scroll-up 2)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ¿
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; եC-f C-fǳ˥饤ɽ
(auto-image-file-mode 1)

;; .gz, .bz2ե򳫤˼ưŸ
(auto-compression-mode t)

;; URLSHIFT-mouse2ǥ֥饦ư
(global-set-key [S-mouse-2] 'browse-url-at-mouse)

;; ⡼ɤǤΥѥɤ򥨥ʤ褦ˤ
(add-hook 'comint-output-filter-functions 'comint-watch-for-password-prompt)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ɲå
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; ոؤΥɥư ERROR
(global-set-key "\C-xp" (lambda () (interactive) (other-window -1)))

;; Goto-Line ESC-g ˤޤ
(global-set-key "\eg" 'goto-line)

;; New-Frame ESC-nf ˤޤ
(global-set-key "\enf" 'new-frame)

;; M-x recompile Ctrl-c tj ˤޤ
(global-set-key "\C-ctj" 'recompile)

;; M-x speedbar f11 ˤޤʥĥ꡼ӥ塼ɽ
(global-set-key [f11] 'speedbar)

;; ؿɽ
(setq load-path (cons "~/lisp" load-path))
(autoload 'se/make-summary-buffer "summarye" nil t)
(global-set-key "\ep" 'se/make-summary-buffer)

;;;
;;; for Mew
;;;
(autoload 'mew "mew" nil t)
(autoload 'mew-send "mew" nil t)

(if (boundp 'read-mail-command)
    (setq read-mail-command 'mew))
(autoload 'mew-user-agent-compose "mew" nil t)
(if (boundp 'mail-user-agent)
    (setq mail-user-agent 'mew-user-agent))
(if (fboundp 'define-mail-user-agent)
    (define-mail-user-agent
      'mew-user-agent
      'mew-user-agent-compose
      'mew-draft-send-message
      'mew-draft-kill
      'mew-send-hook))

;; load-pathɲ
(setq load-path (cons "~/lisp" load-path))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GNU GLOBAL(gtags) gtags.el
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(autoload 'gtags-mode "gtags" "" t)
(setq gtags-mode-hook
      '(lambda ()
	   (local-set-key "\M-t" 'gtags-find-tag)     ;ؿ
	   (local-set-key "\M-r" 'gtags-find-rtag)    ;ؿλ
	   (local-set-key "\M-s" 'gtags-find-symbol)  ;ѿ/
	   (local-set-key "\M-f" 'gtags-find-file)  ;ѿ/
	   (local-set-key "\C-t" 'gtags-pop-stack)  ;ΥХåե
	  ))
;
(global-set-key "\C-cgt" 'gtags-find-tag)    ;ؿ
(global-set-key "\C-cgr" 'gtags-find-rtag)   ;ؿλ
(global-set-key "\C-cgs" 'gtags-find-symbol) ;ѿ/
(global-set-key "\C-cgf" 'gtags-find-file)   ;ե˥ե̾˥
(global-set-key "\C-cgp" 'gtags-find-pattern);ޥåԤ˥
(global-set-key "\C-cg." 'gtags-find-tag-from-here) ; ߥ˥Хåե˥ɤɽľܥ
(global-set-key "\C-cg*" 'gtags-pop-stack)
(global-set-key "\C-c*" 'gtags-pop-stack)    ;ΥХåե
;(global-set-key "\C-cg" 'gtags-mode)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ʬ䤷̤ؤ 
;; f2ؤ or  M-x swap-screen Ǥؤ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun swap-screen()
  "Swap two screen,leaving cursor at current window."
  (interactive)
  (let ((thiswin (selected-window))
        (nextbuf (window-buffer (next-window))))
    (set-window-buffer (next-window) (window-buffer))
    (set-window-buffer thiswin nextbuf)))
(defun swap-screen-with-cursor()
  "Swap two screen,with cursor in same buffer."
  (interactive)
  (let ((thiswin (selected-window))
        (thisbuf (window-buffer)))
    (other-window 1)
    (set-window-buffer thiswin (window-buffer))
    (set-window-buffer (selected-window) thisbuf)))
(global-set-key [f2] 'swap-screen)
(global-set-key [S-f2] 'swap-screen-with-cursor)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; cygwin-mount
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(when (and (featurep 'meadow) (locate-library "cygwin-mount"))
  (require 'cygwin-mount)
  (cygwin-mount-activate))

;;ֹ[F12]ɽON/OFF⡼; (setnu.elɬ)
(autoload 'setnu-mode "setnu" nil t)(global-set-key [f12] 'setnu-mode)

(global-set-key "\C-x\C-b" 'bs-show) ;;bs-showǥХåե򤹤롣

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; C#  csharp-mode.el
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; C# mode
(add-hook 'csharp-mode-hook (lambda ()
                              (setq c-basic-offset 4
                                    tab-width 4
                                    indent-tabs-mode nil)))
(add-hook 'java-mode-hook (lambda () (setq tab-width 4)))
(autoload 'csharp-mode "csharp-mode" "C# editing mode." t)
(setq auto-mode-alist
    (append '(
        ("\\.s?html?\\'" . html-helper-mode)
        ("\\.asp$" . html-helper-mode)
        ("\\.as[phm]x$" . html-helper-mode)
        ("\\.html$" . html-helper-mode)
        ("\\.htm$" . html-helper-mode)
                    ("\\.md$" . emacs-lisp-mode)
        ("\\.txt$" . text-mode)
        ("\\.cs$" . csharp-mode)
    ) auto-mode-alist ))

;; Set Default Compiler Command
(setq-default compile-command "mcs ")
;(setq-default compile-command "csc ") ;Meadow

;; Set Key
(global-set-key "\C-x\c" 'compile)

;; Emacs  subshell  ls ˿դ
;; .bashrc ϡPS1="[\\[\033[31m\]\u \W\[\033[0m\]]\\$ "פʤ
(add-hook 'shell-mode-hook 'ansi-color-for-comint-mode-on)
